import { Component, ViewChild, ElementRef } from '@angular/core';
import { EJComponents } from "ej-angular2/src/ej/core";
import { Scheduler } from 'rxjs';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  public display = false;
  public CurrentDate: Date;
  public GroupData: any;
  public ResourceData: any;
  public BlockoutData: any;
  public AppointmentSettings: any;
  @ViewChild('schedule') Scheduler: EJComponents<any, any>;

  constructor() {
    this.CurrentDate = new Date(2014, 4, 1);
    this.GroupData = {
      resources: ['Owners', 'Rooms']
    };
    this.ResourceData = [
      {
        field: 'ownerId',
        title: 'Owner',
        name: 'Owners',
        resourceSettings: {
          dataSource: [
            { OwnerText: 'Nancy', id: 'lol', OwnerColor: '#f8a398' },
            { OwnerText: 'Steven', id: 'lal', OwnerColor: '#56ca95' }
          ],
          text: 'OwnerText',
          id: 'id',
          color: 'OwnerColor'
        }
      },
      {
        field: 'roomId',
        title: 'Room(s)',
        name: 'Rooms',
        resourceSettings: {
          dataSource: [
            { text: 'Room1', id: 'plop', groupId: 'lol', color: '#f8a398' },
            { text: 'Room2', id: 'EQUIPE-1', groupId: 'lal', color: '#56ca85' },
            { text: 'Room3', id: 3, groupId: 'lal', color: '#56ac88' }
          ],
          text: 'text',
          id: 'id',
          color: 'color',
          groupId: 'groupId'
        }
      }
    ];

    this.AppointmentSettings = {
      dataSource: [
        {
          EventId: 100,
          EventSubject: 'Research on Sky Miracles',
          EventStartTime: new Date(2014, 4, 2, 9, 0),
          EventEndTime: new Date(2014, 4, 2, 10, 30),
          ownerId: 2,
          roomId: 1,
        }
      ],
      id: 'EventId',
      startTime: 'EventStartTime',
      endTime: 'EventEndTime',
      subject: 'EventSubject',
      resourceFields: 'ownerId,roomId'
    };
  }
  public appWindow(args: any) {
    args.cancel = true;
    this.Scheduler.widget._appointmentWindow(args.target);
  }
  public OnAppointmentClick(args: any) {
    args.cancel = true;
    if (!args.appointment.Recurrence)
      this.Scheduler.widget._showAppointmentDetails(args.appointment.Guid, true);
    else {
      if (ej.isNullOrUndefined(this.Scheduler.widget._recurEditWindow)) this.Scheduler.widget._renderRecurEditWindow();
      this.Scheduler.widget._parentId = args.appointment.ParentId;
      this.Scheduler.widget._recurEditWindow.ejDialog("open");
      this.Scheduler.widget._recurEditWindow.focus();
      this.Scheduler.widget._deleteBeforeOpen();
    }

  }
  public onAppointmentWindowOpen(args: any) {
    if (!ej.isNullOrUndefined(args.appointment)) {
      this.Scheduler.widget._currentAction = 'save'
      $("#ScheduleAppointmentAddEditWindow_title").find('.e-title').html("Edit Appointment");
    }
    else
      $("#ScheduleAppointmentAddEditWindow_title").find('.e-title').html("Create Appointment");
  }
}
